#include <stdio.h>
#include <htc.h>
#include "usart.h"
#include "lcd.h"
#include "i2c.h"

__CONFIG(FOSC_XT & WDTE_OFF & PWRTE_ON & MCLRE_ON & CP_OFF & CPD_OFF & BOREN_OFF & CLKOUTEN_ON & IESO_OFF & FCMEN_OFF);

__CONFIG(WRT_OFF & PLLEN_OFF & STVREN_OFF & BORV_25 & LVP_OFF);

#define _XTAL_FREQ  4000000

void init_pic(void)
{
	//OSCCON = 0b01101000;
	PORTA = 0x00;
	PORTB = 0x00;
	ANSELA = 0x00;
	ANSELB = 0b00001000; //analogue input on AN9 (RB3)
	TRISA=0b00000000;
	TRISB=0b00111110;	//set up for I2C and USART, plus ADC input on AN9 (RB3)
}

void main(void)
{
	unsigned char input;
	unsigned char c = 0;

	INTCON=0;	//  disable interrupts.

	init_pic();

	init_comms();	// set up the USART - settings defined in usart.h

	lcd_init();
	lcd_goto(0);  // select first line 

	lcd_puts("UART test");
	lcd_goto(0x40);	// Select second line
	lcd_puts("program");
	__delay_ms(1000);
	lcd_clear();

	// Output a message to prompt the user for a keypress	
	printf("\rChracters entered will be displayed on the LCD\n");


while(1){
		input = getch();	// read a response from the serail port
		{
			lcd_putch(input); //pass to the display
			c++;				//increment the position counter

			if (c == 16)
			{
				lcd_goto(0x40);	// Select second line
			}

			if (c == 33)	//one past the end of the second line
			{
				lcd_clear(); //clear the display ready for the next charcter
				c = 0;
				lcd_putch(input);
			}
		}
		
	}
}